Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/analyzer.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -58,8 +58,8 @@
 
   // ---------- Parse the TE Factors into an array -----------------
-  if (!Energy.ParseIndices()) return 1;
+  //if (!Energy.ParseIndices()) return 1;
   
   // ---------- Parse the Force indices into an array ---------------
-  if (!Force.ParseIndices(argv[1])) return 1;
+  //if (!Force.ParseIndices(argv[1])) return 1;
 
   // ---------- Parse the KeySets into an array ---------------
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/atom.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -26,4 +26,5 @@
   SeparationVertex = false;
   LowpointNr = -1;
+  AdaptiveOrder = 0;
 };
 
Index: src/builder.cpp
===================================================================
--- src/builder.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/builder.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -559,8 +559,5 @@
 void FragmentAtoms(molecule *mol, config *configuration)
 {
-  enum BondOrderScheme Scheme = NoScheme;
-  enum CutCyclicBond CutCyclic;
-  char schema;
-  int Order1, Order2;
+  int Order1;
   clock_t start, end;
   
@@ -568,42 +565,7 @@
   cout << Verbose(0) << "What's the desired bond order: ";
   cin >> Order1;
-  cout << Verbose(0) << "What's the desired bond scheme [(B)ottomUp/(T)opDown/(A)NOVA/(C)ombined]: ";
-  cin >> schema;
-  CutCyclic = SaturateBond;
-  switch (schema) {
-    default:
-        Scheme = NoScheme;
-      break;
-    case 'B':
-        CutCyclic = KeepBond;
-    case 'b':
-        Scheme = BottomUp;
-        Order2 = 0;
-      break;
-    case 'T':
-        CutCyclic = KeepBond;
-    case 't':
-        Scheme = TopDown;
-        Order2 = Order1;
-        Order1 = 0;
-      break;
-    case 'A':
-        CutCyclic = KeepBond;
-    case 'a':
-        Scheme = ANOVA;
-        Order2 = 0;
-      break;
-    case 'C':
-        CutCyclic = KeepBond;
-    case 'c':
-        cout << Verbose(0) << "Combined first selects subgraphs by BottomUp of bond order " << Order1 << " then TopDown to fragment these." << endl;
-        cout << Verbose(0) << "What's the desired bond order for TopDown: ";
-        cin >> Order2;
-        Scheme = Combined;
-      break;
-  };
   if (mol->first->next != mol->last) {  // there are bonds
     start = clock();
-    mol->FragmentMolecule((ofstream *)&cout, Order1, Order2, Scheme, configuration, CutCyclic);
+    mol->FragmentMolecule((ofstream *)&cout, Order1, configuration);
     end = clock();
     cout << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
@@ -759,6 +721,4 @@
   int j, axis, count, faktor;
   int MinimumRingSize = -1;
-  enum BondOrderScheme Scheme = NoScheme;
-  enum CutCyclicBond CutCyclic;
   enum ConfigStatus config_present = absent;
   MoleculeLeafClass *Subgraphs = NULL;
@@ -781,9 +741,10 @@
           case '?':
             cout << "MoleCuilder suite" << endl << "==================" << endl << endl;
-            cout << "Usage: " << argv[0] << "[config file] [-{acepsthH?vfrp}] [further arguments]" << endl; 
+            cout << "Usage: " << argv[0] << "[config file] [-{acefpsthH?vfrp}] [further arguments]" << endl; 
             cout << "or simply " << argv[0] << " without arguments for interactive session." << endl;
             cout << "\t-a Z x1 x2 x3\tAdd new atom of element Z at coordinates (x1,x2,x3)." << endl;
             cout << "\t-c x1 x2 x3\tCenter atoms in domain with a minimum distance to boundary of (x1,x2,x3)." << endl;
             cout << "\t-e <file>\tSets the element database to be parsed from this file (default: elements.db in same dir as " << argv[0] << ")." << endl;
+            cout << "\t-e <dist> <order>\tFragments the molecule in BOSSANOVA manner and stores config files in same dir as config." << endl;
             cout << "\t-h/-H/-?\tGive this help screen." << endl;
             cout << "\t-p <file>\tParse given xyz file and create raw config file from it." << endl;
@@ -954,59 +915,19 @@
                 break;
               case 'f':
-                int i,j;
                 if (flag ==0) flag = 2;  // only set if not already by other command line switch
-                cout << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << " and type " << argv[argptr+2] << "." << endl;
-                if (argc >= argptr+3) {
+                cout << "Fragmenting molecule with bond distance " << argv[argptr] << " angstroem, order of " << argv[argptr+1] << "." << endl;
+                if (argc >= argptr+2) {
                   cout << Verbose(0) << "Creating connection matrix..." << endl;
                   start = clock();
                   mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr++]));
                   cout << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
-                  cout << Verbose(0) << "What's the desired bond scheme [(B)ottomUp/(T)opDown/(A)NOVA/(C)ombined]: ";
-                  CutCyclic = SaturateBond;
-                  switch (argv[argptr+1][0]) {
-                    default:
-                        Scheme = NoScheme;
-                      break;
-                    case 'B':
-                      CutCyclic = KeepBond;
-                    case 'b':
-                        Scheme = BottomUp;
-                        i = atoi(argv[argptr]);
-                        j = 0;
-                      break;
-                    case 'T':
-                      CutCyclic = KeepBond;
-                    case 't':
-                        Scheme = TopDown;
-                        i = 0;
-                        j = atoi(argv[argptr]);
-                      break;
-                    case 'A':
-                      CutCyclic = KeepBond;
-                    case 'a':
-                        Scheme = ANOVA;
-                        i = atoi(argv[argptr]);
-                        j = 0;
-                      break;
-    //                case 'C':
-    //                  CutCyclic = KeepBond;
-    //                case 'c':
-    //                    if (argc > 5) {
-    //                      i = atoi(argv[4]);
-    //                      j = atoi(argv[6]);
-    //                      Scheme = Combined;
-    //                    }
-    //                    else
-    //                      cerr << "Missing second bond order for TopDown fragmentation in combined approach." << endl;
-    //                  break;
-                  };
                   if (mol->first->next != mol->last) {
-                    mol->FragmentMolecule((ofstream *)&cout, i, j, Scheme, &configuration, CutCyclic);
+                    mol->FragmentMolecule((ofstream *)&cout, atoi(argv[argptr]), &configuration);
                   }
                   end = clock();
                   cout << Verbose(0) << "Clocks for this operation: " << (end-start) << ", time: " << ((double)(end-start)/CLOCKS_PER_SEC) << "s." << endl;
-                  argptr+=2;
+                  argptr+=1;
                 } else {
-                  cerr << "Not enough arguments for fragmentation: -f <max. bond distance> <bond order> <type>" << endl;
+                  cerr << "Not enough arguments for fragmentation: -f <max. bond distance> <bond order>" << endl;
                 }
                 break;
Index: src/defs.hpp
===================================================================
--- src/defs.hpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/defs.hpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -18,5 +18,5 @@
 #define VERSIONSTRING "v1.0"
 
-enum BondOrderScheme { NoScheme, BottomUp, TopDown, ANOVA, Combined }; //!< Fragmentation scheme used in BOSS
+//enum BondOrderScheme { NoScheme, BottomUp, TopDown, ANOVA, Combined }; //!< Fragmentation scheme used in BOSS
 
 enum EdgeType { Undetermined, TreeEdge, BackEdge }; //!< edge type in a graph after Depth-First-Search analysis.
@@ -24,5 +24,5 @@
 enum Shading { white, lightgray, darkgray, black };  //!< color in Breadth-First-Search analysis
 
-enum CutCyclicBond { KeepBond,  SaturateBond }; //!< Saturation scheme either atom- or bondwise 
+//enum CutCyclicBond { KeepBond,  SaturateBond }; //!< Saturation scheme either atom- or bondwise 
 
 // Specifting whether a value in the parameter file must be specified or is optional
@@ -44,6 +44,5 @@
 #define KEYSETFILE "KeySets.dat"
 #define ADJACENCYFILE "Adjacency.dat"
-#define TEFACTORSFILE "TE-Factors.dat"
-#define FORCESFILE "Forces-Factors.dat"
+#define ORDERATSITEFILE "OrderAtSite.dat" 
 #define FRAGMENTPREFIX "BondFragment"
 #define STANDARDCONFIG "unknown.conf"
@@ -54,4 +53,5 @@
 #define STANDARDHBONDANGLEDB "Hbondangle.db"
 
+#define UPDATECOUNT 10  //!< update ten sites per BOSSANOVA interval
 
 #endif /*DEFS_HPP_*/
Index: src/joiner.cpp
===================================================================
--- src/joiner.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/joiner.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -46,8 +46,8 @@
 
   // ---------- Parse the TE Factors into an array -----------------
-  if (!Energy.ParseIndices()) return 1;
+  //if (!Energy.ParseIndices()) return 1;
   
   // ---------- Parse the Force indices into an array ---------------
-  if (!Force.ParseIndices(argv[1])) return 1;
+  //if (!Force.ParseIndices(argv[1])) return 1;
   //if (!ParseForceIndices(argv[1], data.ForcesIndices, data.AtomCounter, data.FragmentCounter)) return 1;
 
Index: src/moleculelist.cpp
===================================================================
--- src/moleculelist.cpp	(revision 260934983a76c25770b6a1f5706e2fc4eb1eecec)
+++ src/moleculelist.cpp	(revision db942effae4d25e57224c90078ac288434a4a783)
@@ -21,10 +21,7 @@
 MoleculeListClass::MoleculeListClass(int NumMolecules, int NumAtoms)
 {
-  TEList = (double*) Malloc(sizeof(double)*NumMolecules, "MoleculeListClass:MoleculeListClass: *TEList");
   ListOfMolecules = (molecule **) Malloc(sizeof(molecule *)*NumMolecules, "MoleculeListClass:MoleculeListClass: **ListOfMolecules");
-  for (int i=0;i<NumMolecules;i++) {
-    TEList[i] = 0.;
+  for (int i=0;i<NumMolecules;i++)
     ListOfMolecules[i] = NULL;
-  }
   NumberOfMolecules = NumMolecules;
   NumberOfTopAtoms = NumAtoms;
@@ -36,5 +33,5 @@
 MoleculeListClass::~MoleculeListClass()
 {
-  cout << Verbose(3) << this << ": Freeing ListOfMolcules and TEList." << endl;
+  cout << Verbose(3) << this << ": Freeing ListOfMolcules." << endl;
   for (int i=0;i<NumberOfMolecules;i++) {
     if (ListOfMolecules[i] != NULL) { // if NULL don't free
@@ -46,8 +43,11 @@
   cout << Verbose(4) << "Freeing ListOfMolecules." << endl;
   Free((void **)&ListOfMolecules, "MoleculeListClass:MoleculeListClass: **ListOfMolecules");
-  cout << Verbose(4) << "Freeing TEList." << endl;
-  Free((void **)&TEList, "MoleculeListClass:MoleculeListClass: *TEList");
-};
-
+};
+
+/** Compare whether two molecules are equal.
+ * \param *a molecule one
+ * \param *n molecule two
+ * \return lexical value (-1, 0, +1)
+ */
 int MolCompare(const void *a, const void *b)
 {
@@ -122,165 +122,4 @@
 };
 
-/** Returns an allocated index list which fragment should remain and which are doubly appearing.
- * Again, we use linked cell however not with \a threshold which in most cases is too small and would
- * generate too many cells, but a too be specified \a celldistance which should e.g. be chosen in
- * the magnitude of the typical bond distance. In order to avoid so far the need of a vector list,
- * we simply use the molecule structure and the vector sitting in the atom structure.
- * \param *out output stream for debugging
- * \param **MapList empty but allocated(MoleculeListClass::NumberOfMolecules), containing on return mapping of for which equal molecule which atoms corresponds to which one (needed for ForceFactors)
- * \param threshold threshold value for molecule::IsEqualToWithinThreshold()
- * \param cell_size 6 entries specifying the unit cell vectors (matrix is symmetric)
- * \param celldistance needed for linked-cell technique to find possible equals
- * \return allocated index list with \a Num entries.
- */
-int * MoleculeListClass::GetMappingToUniqueFragments(ofstream *out, double threshold, double *cell_size, double celldistance)
-{
-  int j, UniqueIndex, HighestNumber;
-  //int NumberCells, divisor[NDIM], n[NDIM], N[NDIM], index, Index;
-  int Counter;
-  //molecule **CellList;
-  int *MapList = NULL;
-  size_t *SortMap = NULL;
-  //atom *Walker = NULL, *OtherWalker = NULL;
-  //molecule *LinkedCellContainer = new molecule(NULL);  // container for all the center of gravities stored as atoms
-  
-  /// Allocated MapList with range NumberOfMolecules. 
-  MapList = (int *) Malloc(sizeof(int)*NumberOfMolecules, "MoleculeListClass::GetMappingToUniqueFragments: *MapList");
-  SortMap = (size_t *) Malloc(sizeof(size_t)*NumberOfMolecules, "MoleculeListClass::GetMappingToUniqueFragments: *MapList");
-  for (j=0;j<NumberOfMolecules;j++) {
-    if (ListOfMolecules[j] ==  NULL)
-      cerr << "ERROR: Molecule " << j << " is NULL!" << endl;
-    //else 
-      //cerr << "ERROR: Molecule " << j << " is " << ListOfMolecules[j] << " with count " << ListOfMolecules[j]->AtomCount << "." << endl;
-    MapList[j] = -1;
-    SortMap[j] = 0;
-  }
-  *out << Verbose(1) << "Get mapping to unique fragments with " << NumberOfMolecules << " fragments total." << endl;
-  
-  // sort the list with heapsort according to sort function
-  gsl_heapsort_index(SortMap, ListOfMolecules, NumberOfMolecules, sizeof(molecule *), MolCompare);
-  // check next neighbours and remap
-  Counter = 0;
-  MapList[SortMap[0]] = Counter++;
-  for(int i=1;i<NumberOfMolecules;i++) {
-    if (MolCompare(&ListOfMolecules[SortMap[i]], &ListOfMolecules[SortMap[i-1]]) == 0)
-      MapList[SortMap[i]] = MapList[SortMap[i-1]];
-    else
-      MapList[SortMap[i]] = Counter++; 
-  } 
-  Free((void **)&SortMap, "MoleculeListClass::GetMappingToUniqueFragments: *SortMap");
-
-  *out << Verbose(2) << "Map: ";
-  for(int i=0;i<NumberOfMolecules;i++)
-    *out << MapList[i] << " ";
-  *out << endl;
-
-  // bring MapList indices into an ascending order
-  HighestNumber = Counter;
-  *out << Verbose(3) << "HighestNumber: " << HighestNumber << "." << endl;
-  SortMap = (size_t *) Malloc(sizeof(size_t)*NumberOfMolecules, "MoleculeListClass::GetMappingToUniqueFragments: *SortMap");
-  for(int i=0;i<NumberOfMolecules;i++)
-    SortMap[i] = HighestNumber;   // is the first number that will not appear anymore in list   
-  UniqueIndex = 0;
-  for(int i=0;i<NumberOfMolecules;i++)
-    if (MapList[i] != -1) {
-      if ((unsigned int)SortMap[MapList[i]] == (unsigned int)HighestNumber)
-        SortMap[MapList[i]] = UniqueIndex++;
-      MapList[i] = SortMap[MapList[i]];
-    } else {
-      MapList[i] = -1;
-    }
-  *out << Verbose(2) << "Ascending Map: ";
-  for(int i=0;i<NumberOfMolecules;i++)
-    *out << MapList[i] << " ";
-  *out << endl;
-  Free((void **)&SortMap, "MoleculeListClass::GetMappingToUniqueFragments: *SortMap");
-
-  /// Return the constructed list.
-  return MapList;
-};
-
-
-/** Takes a list of molecules and returns the list with doubles removed.
- * Checks by using molecule::IsEqualToWithinThreshold() whether fragments within the list
- * are actually doubles. If not, the pointer are copied to a new list, if so,
- * they are dropped. The new list is then copied back to the reallocated \a **FragmentList
- * and the new number of elements therein returned.
- * \param *out output stream for debugging
- * \param *Map mapping of which index goes on which (from molecule::GetMappingToUniqueFragments())
- * \return number of molecules in the new realloacted **FragmentList
- */
-int MoleculeListClass::ReduceFragmentToUniqueOnes(ofstream *out, int *Map)
-{
-  *out << Verbose(2) << "Begin of ReduceFragmentToUniqueOnes" << endl;
-  /// Allocate temporary lists of size \a Num.
-  molecule **NewMolList = (molecule **) Malloc(sizeof(molecule *)*NumberOfMolecules, "MoleculeListClass::ReduceFragmentToUniqueOnes: NewList");
-  double *NewTEList = (double *) Malloc(sizeof(double)*NumberOfMolecules, "MoleculeListClass::ReduceFragmentToUniqueOnes: *NewTEList");
-  for(int i=0;i<NumberOfMolecules;i++) {
-    NewTEList[i] = 0;
-    NewMolList[i] = NULL;
-  }
-  int ReducedNum = 0, j;
-  *out << Verbose(3) << "Reducing TE and Forces lists." << endl;
-  for(int i=0;i<NumberOfMolecules;i++) {                       /// Count new reduced number of molecules ...
-    //*out << Verbose(4) << i << "th TE Value " << " goes to " << Map[i] << ": " << TEList[i] << "." << endl;
-    NewTEList[Map[i]] += TEList[i];
-    if (Map[i] == i) {                           /// ... by checking if Map[i] != i, then Fragment[i] is double of Fragment[Map[i]].
-      *out << Verbose(4) << "Copying molecule " << i << " as it is unique so far ... " << ListOfMolecules[i]<< endl;
-      NewMolList[ReducedNum++] = ListOfMolecules[i];   /// ..., whilst copying each value to temporary list, ...
-    } else {  // else free molecule cause it appears doubly
-      *out << Verbose(4) << "Removing molecule " << i << "." << endl;
-      delete(ListOfMolecules[i]);
-      ListOfMolecules[i] = NULL;
-    }
-  }
-  /// Reallocate \a **FragmentList ...
-  *out << Verbose(3) << "Reallocating to Unique Fragments:" << endl;
-  if ((ReducedNum != 0) && (TEList != 0)) {
-    // factor list
-    *out << Verbose(4) << "Reallocating TEList [" << TEList << "] to " << ReducedNum << endl;
-    TEList = (double *) ReAlloc(TEList, sizeof(double)*ReducedNum, "MoleculeListClass::ReduceFragmentToUniqueOnes: *TEList");
-
-    *out << Verbose(4) << "Copying values to new list: " << endl;
-    j = 0;  // is ReducedNum index
-    for(int i=0;i<NumberOfMolecules;i++) {/// copy value from temporary to return list
-      if (Map[i] == i) {
-      //if (fabs(NewTEList[i]) > MYEPSILON) { // this is a good check also, if TEList[i] = 0 then fragment cancels and may be dropped!
-        TEList[j] = NewTEList[i];
-        *out << Verbose(5) << "TE [i" << i << "<->j" << j << "]:" << NewTEList[i] << "->" << TEList[j];
-        j++;
-      }
-      *out << endl;
-    }
-    if (j != ReducedNum)
-      *out << "Panic:  j " << j << " != ReducedNum " << ReducedNum << "." << endl;
-      
-
-    // molecule list
-    *out << Verbose(4) << "Reallocating ListOfMolecules ... " << endl;
-    ListOfMolecules = (molecule **) ReAlloc(ListOfMolecules, sizeof(molecule *)*ReducedNum, "MoleculeListClass::ReduceFragmentToUniqueOnes: ListOfMolecules");
-    NumberOfMolecules = ReducedNum;
-    /// ... and copy the reduced number back
-    *out << Verbose(5) << "Transfering to ListOfMolecules ... ";
-    for(int i=0;i<ReducedNum;i++) {
-      ListOfMolecules[i] = NewMolList[i];
-      *out << NewMolList[i] << " -> " << ListOfMolecules[i] << "\t";
-    }
-    *out << endl;
-
-
-  } else {
-    Free((void **)&ListOfMolecules, "MoleculeListClass::ReduceFragmentToUniqueOnes: ListOfMolecules");
-    NumberOfMolecules = ReducedNum;
-    *out << Verbose(3) << "ReducedNum is " << ReducedNum << ", Number of Molecules is " << NumberOfMolecules << "." << endl;
-  }
-  // free all the lists again
-  *out << Verbose(3) << "Freeing temporary lists." << endl;
-  Free((void **)&NewTEList, "MoleculeListClass::ReduceFragmentToUniqueOnes: *NewTEList");      /// free temporary list again
-  Free((void **)&NewMolList, "MoleculeListClass::ReduceFragmentToUniqueOnes: *NewMolList");
-  *out << Verbose(2) << "End of ReduceFragmentToUniqueOnes" << endl;
-  return(ReducedNum);
-};
-
 /** Simple output of the pointers in ListOfMolecules.
  * \param *out output stream
@@ -295,11 +134,10 @@
 
 /** Writes a config file for each molecule in the given \a **FragmentList.
- * Note that molecules with a TEList factor of 0 are not stored!
- * \param *prefix prefix for the file name
+ * \param *out output stream for debugging
  * \param *configuration standard configuration to attach atoms in fragment molecule to.
  * \param *SortIndex Index to map from the BFS labeling to the sequence how of Ion_Type in the config
  * \return true - success (each file was written), false - something went wrong.
  */
-bool MoleculeListClass::OutputConfigForListOfFragments(char *prefix, config *configuration, int *SortIndex)
+bool MoleculeListClass::OutputConfigForListOfFragments(ofstream *out, config *configuration, int *SortIndex)
 {
   ofstream outputFragment;
